#ifndef _TEST_MEMORY_H_
#define _TEST_MEMORY_H_

#include <stdint.h>
#include "llpi_parallel_flash.h"

//..............................................................................
typedef enum {e_walk_data_zero = 0,
              e_walk_data_one,
              e_walk_address_zero,
              e_walk_address_one,
              e_byte_enable} test_memory_walk_kind_t;
//..............................................................................

//..............................................................................
typedef enum {e_shared_sdram} memory_kind_t;
//..............................................................................

//..............................................................................
extern memory_kind_t memory_under_test;
//..............................................................................

//..............................................................................
extern bool     test_memory_walk_data               (uint32_t base, uint32_t size, test_memory_walk_kind_t walk_kind);
extern bool     test_memory_walk_address_one        (uint32_t base, uint32_t size);
extern bool     test_memory_walk_address_zero       (uint32_t base, uint32_t size);
extern bool     test_memory_byte_enable             (uint32_t base, uint32_t size);
//..............................................................................

#endif

